# Class VulkanAttachmentReference.Builder

java.lang.Object
com.io7m.jcoronado.api.VulkanAttachmentReference.Builder

Enclosing class:
  `VulkanAttachmentReference`

public static final class VulkanAttachmentReference.Builder extends Object
Builds instances of type `VulkanAttachmentReference`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `VulkanAttachmentReference`
  `build()`
  Builds a new `VulkanAttachmentReference`.
  `final VulkanAttachmentReference.Builder`
  `from(VulkanAttachmentReferenceType instance)`
  Fill a builder with attribute values from the provided `VulkanAttachmentReferenceType` instance.
  `final VulkanAttachmentReference.Builder`
  `setAttachment(int attachment)`
  Initializes the value for the `attachment` attribute.
  `final VulkanAttachmentReference.Builder`
  `setLayout(VulkanImageLayout layout)`
  Initializes the value for the `layout` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final VulkanAttachmentReference.Builder from(VulkanAttachmentReferenceType instance)
    Fill a builder with attribute values from the provided `VulkanAttachmentReferenceType` instance. Regular attribute values will be replaced with those from the given instance. Absent optional values will not replace present values.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### setAttachment

    public final VulkanAttachmentReference.Builder setAttachment(int attachment)
    Initializes the value for the `attachment` attribute.
    Parameters:
      `attachment` - The value for attachment
    Returns:
      `this` builder for use in a chained invocation

  - ### setLayout

    public final VulkanAttachmentReference.Builder setLayout(VulkanImageLayout layout)
    Initializes the value for the `layout` attribute.
    Parameters:
      `layout` - The value for layout
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public VulkanAttachmentReference build()
    Builds a new `VulkanAttachmentReference`.
    Returns:
      An immutable instance of VulkanAttachmentReference
    Throws:
      `IllegalStateException` - if any required attributes are missing